package ejb;

import javax.ejb.Remote;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.MediaType;

import jpa.ActividadUpdateJPA;
import jpa.FaseUpdateJPA;
import jpa.ListaJPA;
import jpa.ParteJPA;
import jpa.ParteUpdateJPA;
import jpa.UsuarioJPA;
import rest.RespuestaRest;

@Remote
@Path(value = "partes")
public interface DTFacadeRemote {

	@GET
	@Path("/login/{usr}/{pass}")
	@Produces(MediaType.APPLICATION_JSON)
	public RespuestaRest<UsuarioJPA> login(@PathParam("usr") String usr,
			@PathParam("pass") String pass);

	@POST
	@Path("/logout/{idUsuario}")
	@Produces(MediaType.APPLICATION_JSON)
	public RespuestaRest<String> logout(@PathParam("idUsuario") int idUsuario);

	@GET
	@Path("/ultimoParte/{idUsuario}")
	@Produces(MediaType.APPLICATION_JSON)
	public RespuestaRest<ParteJPA> ultimoParte(@PathParam("idUsuario") int idUsuario);

	@GET
	@Path("/nuevoParte/{idUsuario}/{coordenadas}")
	@Produces(MediaType.APPLICATION_JSON)
	public RespuestaRest<ParteJPA> nuevoParte(@PathParam("idUsuario") int idUsuario, @PathParam("coordenadas") String coordenadas);

	@POST
	@Path("/actualizarParte")
	@Consumes(MediaType.APPLICATION_JSON)
	@Produces(MediaType.APPLICATION_JSON)
	public RespuestaRest<ParteJPA> actualizarParte(ParteUpdateJPA parte);

	@GET
	@Path("/cerrarParte/{idParte}/{coordenadas}")
	public RespuestaRest<String> cerrarParte(@PathParam("idParte") int idParte, @PathParam("coordenadas") String coordenadas);

	@GET
	@Path("/nuevaActividad/{idParte}/{coordenadas}")
	@Produces(MediaType.APPLICATION_JSON)
	public RespuestaRest<ParteJPA> nuevaActividad(@PathParam("idParte") int idParte, @PathParam("coordenadas") String coordenadas, @QueryParam("tipo") int tipo);

	@POST
	@Path("/actualizarActividad/{idParte}")
	@Consumes(MediaType.APPLICATION_JSON)
	@Produces(MediaType.APPLICATION_JSON)
	public RespuestaRest<ParteJPA> actualizarActividad(@PathParam("idParte") int idParte, ActividadUpdateJPA actividad);

	@GET
	@Path("/cerrarActividad/{idActividad}/{coordenadas}")
	public RespuestaRest<ParteJPA> cerrarActividad(@PathParam("idActividad") int idActividad, @PathParam("coordenadas") String coordenadas);

	@POST
	@Path("/actualizarFase/{idParte}")
	@Consumes(MediaType.APPLICATION_JSON)
	@Produces(MediaType.APPLICATION_JSON)
	public RespuestaRest<ListaJPA> actualizarFase(@PathParam("idParte") int idParte, FaseUpdateJPA fase);

	@GET
	@Path("/siguienteFase/{idParte}/{idFase}")
	@Produces(MediaType.APPLICATION_JSON)
	public RespuestaRest<ListaJPA> siguienteFase(@PathParam("idParte") int idParte, @PathParam("idFase") int idFase);

}
