package filters;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Filtra que comproba que l'usuari estigui auntenticat per accedir a la pàgina usuariosPartesView.xhtml
 */
@WebFilter(urlPatterns = { "/usuariosPartesView.xhtml" })
public class AutenticacionWeb implements Filter {
	
	@SuppressWarnings("unused")
	private FilterConfig config;

    /**
     * Default constructor. 
     */
    public AutenticacionWeb() {
    }

	/**
	 * @see Filter#destroy()
	 */
	public void destroy() {
		config = null;
	}

	/**
	 * @see Filter#doFilter(ServletRequest, ServletResponse, FilterChain)
	 */
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
		
		if (((HttpServletRequest) request).getSession().getAttribute("user") == null) {
		      ((HttpServletResponse) response).sendRedirect("loginView.xhtml");
		    } else {
		      chain.doFilter(request, response);
		    }
	}

	/**
	 * @see Filter#init(FilterConfig)
	 */
	public void init(FilterConfig fConfig) throws ServletException {
		this.config = fConfig;
	}

}
