package jpa;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import javax.persistence.Table;

/**
 * Classe que implementa una fase en format reduït per aprofitar la desserialització JSON automàtica de la llibreria Jackson i actualitzar les entitats amb tan sols una comanda 'merge'.
 * @author Guillem
 *
 */
@Entity
@Table(name = "tfg.fases")
public class FaseUpdateJPA implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	private int id;
	
	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
	@JoinColumn(name = "fase")
	@OrderBy("id")
	private Set<RequisitoUpdateJPA> requisitos;

	public FaseUpdateJPA() {
		this.requisitos = new HashSet<RequisitoUpdateJPA>();
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Set<RequisitoUpdateJPA> getRequisitos() {
		return requisitos;
	}

	public void setRequisitos(Set<RequisitoUpdateJPA> requisitos) {
		this.requisitos = requisitos;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		FaseUpdateJPA other = (FaseUpdateJPA) obj;
		if (id != other.id)
			return false;
		return true;
	}

}
