package jpa;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

/**
 * Classe que implementa un comunicat en format reduït per aprofitar la desserialització JSON automàtica de la llibreria Jackson i actualitzar les entitats amb tan sols una comanda 'merge'.
 * @author Guillem
 *
 */
@Entity
@Table(name = "tfg.partes")
public class ParteUpdateJPA implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int id;

	private String inicioComunicado;
	private String finComunicado;

	public ParteUpdateJPA() {
		super();
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getInicioComunicado() {
		return inicioComunicado;
	}

	public void setInicioComunicado(String inicioComunicado) {
		this.inicioComunicado = inicioComunicado;
	}

	public String getFinComunicado() {
		return finComunicado;
	}

	public void setFinComunicado(String finComunicado) {
		this.finComunicado = finComunicado;
	}
}
