package jpa;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

/**
 * Classe que implementa un requisit en format reduït per aprofitar la desserialització JSON automàtica de la llibreria Jackson i actualitzar les entitats amb tan sols una comanda 'merge'.
 * @author Guillem
 *
 */
@Entity
@Table(name = "tfg.requisitos")
public class RequisitoUpdateJPA implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int id;

	private String valor = "";
	private String comentario = "";

	public RequisitoUpdateJPA() {
		super();
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getValor() {
		return valor;
	}

	public void setValor(String valor) {
		this.valor = valor;
	}

	public String getComentario() {
		return comentario;
	}

	public void setComentario(String comentario) {
		this.comentario = comentario;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RequisitoUpdateJPA other = (RequisitoUpdateJPA) obj;
		if (id != other.id)
			return false;
		return true;
	}

}
