package jpa;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import javax.persistence.Table;

@Entity
@Table(name = "tfg.tipos_fase")
public class TipoFaseJPA implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int id;

	private String nombre;
	private int orden;

	@ManyToOne
	@JoinColumn(name = "tipo_lista")
	private TipoListaJPA tipo_lista;

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
	@JoinColumn(name = "tipo_fase")
	@OrderBy("id")
	private Set<TipoRequisitoJPA> tipos_requisito;

	public TipoFaseJPA() {
		this.tipos_requisito = new HashSet<TipoRequisitoJPA>();
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public int getOrden() {
		return orden;
	}

	public void setOrden(int orden) {
		this.orden = orden;
	}

	public TipoListaJPA getTipo_lista() {
		return tipo_lista;
	}

	public void setTipo_lista(TipoListaJPA tipo_lista) {
		this.tipo_lista = tipo_lista;
	}

	public Set<TipoRequisitoJPA> getTipos_requisito() {
		return tipos_requisito;
	}

	public void setTipos_requisito(Set<TipoRequisitoJPA> tipos_requisito) {
		this.tipos_requisito = tipos_requisito;
	}

}
