package jpa;

import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import javax.persistence.Table;

@Entity
@Table(name = "tfg.tipos_lista")
public class TipoListaJPA implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int id;

	private String nombre;
	private int maxFases;

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
	@JoinColumn(name = "tipo_lista")
	@OrderBy("id")
	private Set<TipoFaseJPA> tipos_fase;

	public TipoListaJPA() {
		this.tipos_fase = new HashSet<TipoFaseJPA>();
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public int getMaxFases() {
		return maxFases;
	}

	public void setMaxFases(int maxFases) {
		this.maxFases = maxFases;
	}

	public Set<TipoFaseJPA> getTipos_fase() {
		return tipos_fase;
	}

	public void setTipos_fase(Set<TipoFaseJPA> tipos_fase) {
		this.tipos_fase = tipos_fase;
	}

}
