package jpa;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

@Entity
@Table(name = "tfg.tipos_requisito")
public class TipoRequisitoJPA implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	private int id;

	private String nombre;
	private String ayuda;

	@ManyToOne
	@JoinColumn(name = "tipo_fase")
	private TipoFaseJPA tipo_fase;

	public TipoRequisitoJPA() {
		super();
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getNombre() {
		return nombre;
	}

	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	public String getAyuda() {
		return ayuda;
	}

	public void setAyuda(String ayuda) {
		this.ayuda = ayuda;
	}

	public TipoFaseJPA getTipo_fase() {
		return tipo_fase;
	}

	public void setTipo_fase(TipoFaseJPA tipo_fase) {
		this.tipo_fase = tipo_fase;
	}

}
