package managedbean;

import javax.ejb.EJB;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import ejb.DTFacadeLocal;
import jpa.UsuarioJPA;

@ManagedBean(name = "lmb")
@SessionScoped
public class LoginMBean {
	
	@EJB
	private DTFacadeLocal dtLocal;

	private String login;
	private String pass;
	private UsuarioJPA usuario;

	private FacesContext context = FacesContext.getCurrentInstance();
	private HttpServletRequest request = (HttpServletRequest) context.getExternalContext().getRequest();
	private HttpSession sesion = (HttpSession) request.getSession(true);
	
	public LoginMBean(){
		this.login = "";
		this.pass = "";
	}

	public String getLogin() {
		return login;
	}

	public void setLogin(String login) {
		this.login = login;
	}

	public String getPass() {
		return pass;
	}

	public void setPass(String pass) {
		this.pass = pass;
	}

	public UsuarioJPA getUsuario() {
		return usuario;
	}

	public void setUsuario(UsuarioJPA usuario) {
		this.usuario = usuario;
	}

	public String login(){
		usuario = dtLocal.autenticarUsuario(login, pass);
		if (usuario==null){
			FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "Autenticación incorrecta.", ""));
			return (login=pass=null);
		}else{
			sesion.setAttribute("user",usuario);
			return "usuariosPartesView?faces-redirect=true";
		}
	}
	
	public String logout(){
		this.usuario = null;
		this.login = null;
		this.pass = null;
		this.sesion.invalidate();
		return "loginView?faces-redirect=true";
	}
}
