package rest;

import java.io.Serializable;

/**
 * Classe que implementa un objecte de resposta tipus per tal d'interactuar millor amb l'aplicació mòbil.
 * @author Guillem
 *
 * @param <T>	Paràmetre de tipus generic que permet que la classe tingui una propietat el tipus de la cual podem decidir quan generem una nova instancia de la classe.
 */
public class RespuestaRest<T> implements Serializable {

	private static final long serialVersionUID = 1L;
	
	private String codigo;
	private String mensaje;
	private String tipoDatos;
	private T datos;

	public RespuestaRest() {
	}

	public String getCodigo() {
		return this.codigo;
	}

	public void setCodigo(String codigo) {
		this.codigo = codigo;
	}

	public String getMensaje() {
		return mensaje;
	}

	public void setMensaje(String mensaje) {
		this.mensaje = mensaje;
	}
	
	public String getTipoDatos() {
		return tipoDatos;
	}

	public void setTipoDatos(String tipoDatos) {
		this.tipoDatos = tipoDatos;
	}

	public T getDatos() {
		return datos;
	}

	public void setDatos(T datos) {
		this.datos = datos;
	}
}
