/**
 * 
 */
var app = {
    // Application Constructor
    initialize: function() {
        document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
        document.addEventListener("backbutton", function(e){
            if($.mobile.activePage.is('#login-page')){
                navigator.app.exitApp();
            } else if($.mobile.activePage.is('#menu-page')){
                navigator.app.exitApp();
            } else if($.mobile.activePage.is('#parte-page')){
            	$.mobile.changePage('#menu-page')
            } else if($.mobile.activePage.is('#lista-page')){
            	$.mobile.changePage('#parte-page')
            }
        }, false);
        $('input,select').keypress(function(event) { return event.keyCode != 13; });
    },

    // deviceready Event Handler
    //
    // Bind any cordova events here. Common events are:
    // 'pause', 'resume', etc.
    onDeviceReady: function() {
//        this.receivedEvent('deviceready');
    },

    // Update DOM on a Received Event
    receivedEvent: function(id) {
//        var parentElement = document.getElementById(id);
//        var listeningElement = parentElement.querySelector('.listening');
//        var receivedElement = parentElement.querySelector('.received');
//
//        listeningElement.setAttribute('style', 'display:none;');
//        receivedElement.setAttribute('style', 'display:block;');
//
//        console.log('Received Event: ' + id);
    }
};

app.initialize();

document.addEventListener("deviceready", function(){init();});
function init() {
	
}


var URLbase = "http://localhost/jee/sw/partes/";

var idUsuario = 0;
var idParte = 0;
var pagina = "#login-page";
var coordenadas;

$("#btn-acceder").click( function(event, ui) {	
	event.preventDefault();
	clickBotonAcceder();
} );

$(".btn-logout").click( function(event, ui) {	
	event.preventDefault();
	mostrarSpinner();
	var url = 'logout/' + idUsuario;
	$.ajax({			
	    url: URLbase + url,
	    type: 'POST',
	    dataType: 'json',
	    error: function (){ 
	    	ocultarSpinner();
	    	toast("Error en la conexión");}, 
	    success: function (respuesta) {
	    	ocultarSpinner();
	    	toast(respuesta.mensaje);
	    	if(respuesta.codigo === "200") {
	    		token = "";
	    		idUsuario = 0;
	    		$("#txt-usuario").val("");
	    		$("#txt-password").val("");
	    		window.location.href = "#login-page";
		    }
	    }
	});
} );

function clickBotonAcceder() {
	if(validarLogin()) {		
		mostrarSpinner();
		console.log(URLbase + 'login/'+$("#txt-usuario").val()+"/"+$("#txt-password").val());
		$.ajax({
		    url: URLbase + 'login/'+$("#txt-usuario").val()+"/"+$("#txt-password").val(),
		    type: 'GET',
		    dataType: 'json',
		    error : function (){ 
		    	ocultarSpinner();
		    	toast("Error en la conexión.");}, 
		    success: function (respuesta) {
				ocultarSpinner();
			    if(respuesta.codigo === "200") {
					idUsuario = respuesta.datos.id;
					token = respuesta.datos.token;
				    window.location.href = "#menu-page";
			    } else {
			    	toast(respuesta.mensaje);
			    }
		    }
		});		
	}	
}

function validarLogin() {
	
	if(!$("#txt-usuario").val() || !$("#txt-password").val()){
		toast("Introduzca usuario y contraseña.");
		return false;		
	}
	return true;	
}

function mostrarSpinner() {
	$.mobile.loading('show', {
		text : "Cargando",
		textVisible : true,
		theme : "a",
		textonly : false,
		html : ""
	});
}

function ocultarSpinner() {
	$.mobile.loading("hide");
}

$("#btn-ultimo-parte").click(function click(event, ui) {
	event.preventDefault();
	var url = 'ultimoParte/' + idUsuario;
	ajax(url);
});

function onError(error) {
	coordenadas = '999, 999';
}

$("#btn-nuevo-parte").click(function click(event, ui) {
	event.preventDefault();
	navigator.geolocation.getCurrentPosition(function(position) {
	    coordenadas = position.coords.latitude + ', ' + position.coords.longitude;
	    var url = 'nuevoParte/' + idUsuario + '/' + coordenadas;
		ajax(url);
	}, onError, {timeout: 2000, enableHighAccuracy: true});
});

$("form#f-parte").submit(function(event){
	event.preventDefault();
	var form = this;
	guardarParte(form);
});

$("#btn-fin-parte").click(function click(event, ui) {
	event.preventDefault();
	window.location.href = "#menu-page";
	navigator.geolocation.getCurrentPosition(function(position) {
	    coordenadas = position.coords.latitude + ', ' + position.coords.longitude;
	    var url = 'cerrarParte/' + idParte + '/' + coordenadas;
		ajax(url);
	}, onError, {timeout: 2000, enableHighAccuracy: true});
});

$("#sl-tipo-actividad").change(function change(event, ui) {
	event.preventDefault();
	var tipoActividad = $("#sl-tipo-actividad").val();
	navigator.geolocation.getCurrentPosition(function(position) {
	    coordenadas = position.coords.latitude + ', ' + position.coords.longitude;
	    var url = 'nuevaActividad/' + idParte + "/" + coordenadas + '?tipo=' + tipoActividad;
		$("#sl-tipo-actividad").val(0);
		$("#sl-tipo-actividad").selectmenu("refresh");
		ajax(url);
	}, onError, {timeout: 2000, enableHighAccuracy: true});
});

function ajax(url) {
	mostrarSpinner();
	$.ajax({
		url : URLbase + url,
		type : 'GET',
		dataType : 'json',
		error : function() {
			ocultarSpinner();
			toast("Error en la conexión.");
		},
		success : function(respuesta) {
			ocultarSpinner();
			toast(respuesta.mensaje);
			if(respuesta.codigo === "200") {
				if(respuesta.datos != null) {
					if(respuesta.tipoDatos === "parte"){
						mostrarParte(respuesta.datos);
					} else if(respuesta.tipoDatos === "lista") {
						mostrarLista(respuesta.datos);
					}
				} else {
					window.location.href = "#menu-page";
				}
		    }
		}
	});
};

function ajaxJson(url, json) {
	mostrarSpinner();
	$.ajax({
		url : URLbase + url,
		type : 'POST',
		contentType: "application/json; charset=utf-8",
		data : json,
		dataType : 'json',
		error : function() {
			ocultarSpinner();
			toast("Error en la conexión.");
		},
		success : function(respuesta) {
			ocultarSpinner();
			toast(respuesta.mensaje);
			if(respuesta.codigo === "200") {
				if(respuesta.tipoDatos === "parte"){
					mostrarParte(respuesta.datos);
				} else if(respuesta.tipoDatos === "lista") {
					mostrarLista(respuesta.datos);
				}
		    }
		}
	});
};

function mostrarParte(parte){
	if (parte != null) {
			vaciarParte();
			idParte = parte.id;
			$("#parte-id").val(parte.id);
			$("#sp-parte-inicio").text("[" + parte.inicio + "]");
			$("#parte-inicioComunicado").val(parte.inicioComunicado);
			$("#sp-fin-parte").text("[" + parte.fin + "]");
			$("#parte-finComunicado").val(parte.finComunicado);
			$.each(parte.actividades, function(claveActividad, actividad){
				if(actividad.abierta){
					var contActividades = "<div data-role='collapsible' id='c-actividad" + actividad.id + "'>" +
					"<h4>" + actividad.tipo.nombre + "</h4>" +
					"<form id='f-actividad" + actividad.id + "'>" +
					"<input name='id' type='hidden' value='" + actividad.id + "'>" +
					"<p><span class='ui-title-left'>Transporte: </span><input name='transporte' type='text' value='" + actividad.transporte + "'></p>" +
					"<p><span class='ui-title-left'>Vehículo: </span><input name='vehiculo' type='text' value='" + actividad.vehiculo + "'></p>" +
					"<p><span class='ui-title-left'>Remolque: </span><input name='remolque' type='text' value='" + actividad.remolque + "'></p>" +
					"<p><span class='ui-title-left'>Origen: </span><input name='origen' type='text' value='" + actividad.origen + "'></p>" +
					"<p><span class='ui-title-left'>Inicio: </span><input name='inicioComunicado' type='datetime-local' value='" + actividad.inicioComunicado + "'>[<span>" + actividad.inicio + "</span>]</p>" +
					"<p><span class='ui-title-left'>Cuentakilómetros Inicio: </span><input name='cuentaKilometrosInicio' type='number' value='" + actividad.cuentaKilometrosInicio + "'></p>" +
					"<p><span class='ui-title-left'>Destino: </span><input name='destino' type='text' value='" + actividad.destino + "'></p>" +
					"<p><span class='ui-title-left'>Fin: </span><input name='finComunicado' type='datetime-local' value='" + actividad.finComunicado + "'>[<span>" + actividad.fin + "</span>]</p>" +
					"<p><span class='ui-title-left'>Cuentakilómetros Fin: </span><input name='cuentaKilometrosFin' type='number' value='" + actividad.cuentaKilometrosFin + "'></p>" +
					"<input type='submit' value='Guardar'>" +
					"</form>" +
					"<input id='btn-actividad" + actividad.id + "-fin' type='button' value='Finalizar actividad'>";
					
					if(actividad.listas.length != 0){
						contActividades += "<input id='btn-actividad" + actividad.id + "-lista' type='button' value='Ver lista de comprobación'>";
					}
					contActividades += "</div>";
					$("#cp-actividades").append(contActividades);
					$("form#f-actividad" + actividad.id + "").submit(function(event){
						event.preventDefault();
						var form = this;
						guardarActividad(form);
					});
					$("#btn-actividad" + actividad.id + "-fin").click(function(){
						navigator.geolocation.getCurrentPosition(function(position) {
						    coordenadas = position.coords.latitude + ', ' + position.coords.longitude;
						    var url = 'cerrarActividad/' + actividad.id + "/" + coordenadas;
							ajax(url);
						}, onError, {timeout: 2000, enableHighAccuracy: true});
					});
					$("#btn-actividad" + actividad.id + "-lista").click(function(){
						mostrarLista(actividad.listas[0]);
					});
					
					
				} else {
					var contActividades = "<div data-role='collapsible'>" +
					"<h4>" + actividad.tipo.nombre + "</h4>" +								
					"<p><span class='ui-title-left'>Transporte: </span><span>" + actividad.transporte + "</span></p>" +
					"<p><span class='ui-title-left'>Vehículo: </span><span>" + actividad.vehiculo + "</span></p>" +
					"<p><span class='ui-title-left'>Remolque: </span><span>" + actividad.remolque + "</span></p>" +
					"<p><span class='ui-title-left'>Inicio: </span><span>" + actividad.inicioComunicada + "</span>[<span>" + actividad.inicio + "</span>]</p>" +
					"<p><span class='ui-title-left'>Cuentakilómetros Inicio: </span><span>" + actividad.cuentaKilometrosInicio + "</span></p>" +
					"<p><span class='ui-title-left'>Origen: </span><span>" + actividad.origen + "</span></p>" +
					"<p><span class='ui-title-left'>Fin: </span><span>" + actividad.finComunicado + "</span>[<span>" + actividad.inicio + "</span>]</p>" +
					"<p><span class='ui-title-left'>Cuentakilómetros Fin: </span><span>" + actividad.cuentaKilometrosFin + "</span></p>" +
					"<p><span class='ui-title-left'>Destino: </span><span>" + actividad.destino + "</span></p>";
					
					if(actividad.listas.length != 0){
						contActividades += "<input id='btn-actividad" + actividad.id + "-lista' type='button' value='Ver lista de comprobación'>";
					}
					contActividades += "</div>";
					$("#cp-actividades").append(contActividades);
					$("#btn-actividad" + actividad.id + "-lista").click(function(){
						mostrarLista(actividad.listas[0]);
					});
				}
				
			});
			window.location.href = "#parte-page";
			if(parte.actividades.length != 0){
				$("#cp-actividades").collapsibleset("refresh");
				$("#cp-actividades").enhanceWithin();
			}

	} else {
		toast("Parte incorrecto.");
	}
};

function vaciarParte(){
	$("#cp-actividades").empty();
};

function guardarParte(form){
	var parte = $(form).serializeArray();
	var json = {};
    
    $.each(parte, function() {
    	json[this.name] = this.value || '';
    });
    
    var str = JSON.stringify(json);
    var url = "actualizarParte";
    ajaxJson(url, str);
}

function guardarActividad(form){
	var actividad = $(form).serializeArray();
	var json = {};
    
    $.each(actividad, function() {
    	json[this.name] = this.value || '';
    });
    
    var str = JSON.stringify(json);
    var url = "actualizarActividad/" + idParte;
    ajaxJson(url, str);
};

function guardarFase(form){
	var id = $(form).find("#idFase").val();
	var fase = {"id": "" + id + "","requisitos" : []};
	
	$(form).find(".d-requisito").each(function(){
		var requisitos = $(this).find(":input").serializeArray();
		var requisito = {};
		$.each(requisitos, function() {
			requisito[this.name] = this.value || '';
	    });
		fase.requisitos.push(requisito);
	});
    
    var str = JSON.stringify(fase);
    var url = "actualizarFase/" + idParte;
    ajaxJson(url, str);
};

function siguienteFase(idFase){
	var url = "siguienteFase/" + idParte + "/" + idFase;
	ajax(url);
};

function vaciarLista(){
	$("#cp-lista").empty();
};

function mostrarLista(lista){
	vaciarLista();
	if(lista.fases.length != 0){
		var mostrada = false;
		$.each(lista.fases, function(claveFase, fase){
			if(fase.abierta && !mostrada){
				var contLista = "<div data-role='collapsible' id='c-lista" + fase.id + "'>" +
				"<h4>" + fase.nombre + "</h4>" +
				"<form id='f-fase" + fase.id + "'>" +
				"<input id='idFase' type='hidden' class='sp-requisito-id' value='" + fase.id + "'>";
				
				$.each(fase.requisitos, function(claveRequisito, requisito){
					contLista += "<div class='d-requisito'><input name='id' type='hidden' class='sp-requisito-id' value='" + requisito.id + "'>" +
							"<p><span class='ui-title-left'>" + requisito.nombre + "</span>";
							
							contLista += "<select class='s-requisito' name='valor'>"
							if(requisito.valor == ""){
								contLista += "<option value='' selected='selected'></option>";
							} else {
								contLista += "<option value=''></option>";
							};
							if(requisito.valor == "BIEN"){
								contLista += "<option value='BIEN' selected='selected'>BIEN</option>";
							} else {
								contLista += "<option value='BIEN'>Bien</option>";
							};
							if(requisito.valor == "MAL"){
								contLista += "<option value='MAL' selected='selected'>MAL</option>";
							} else {
								contLista += "<option value='MAL'>Mal</option>";
							};
							if(requisito.valor == "NP"){
								contLista += "<option value='NP' selected='selected'>NP</option>";
							} else {
								contLista += "<option value='NP'>No procede</option>";
							};
							contLista += "</select>";
							
							contLista += "</p><p><span class='ui-title-left'>Comentario: </span>" +
							"<input name='comentario' type='text' class='sp-requisito' value='" + requisito.comentario + "'></p>" +
							"</div>";
				});
				contLista += "<input id='bf-fase" + fase.id + "' type='submit' value='Guardar'>" +
						"</form>";
				if(fase.orden < lista.maxFases){
					contLista += "<input id='b-fase" + fase.id + "' type='button' value='Siguiente fase'>";
				}
				contLista += "</div>";
				$("#cp-lista").append(contLista);
				mostrada = true;
				$("form#f-fase" + fase.id + "").submit(function(event){
					event.preventDefault();
					var form = this;
					guardarFase(form);
				});
				$("#b-fase" + fase.id + "").click(function(){
					siguienteFase(fase.id);
				});
			
			} else if(!fase.abierta) {
				var contLista = "<div data-role='collapsible' id='c-lista" + fase.id + "'>" +
				"<h4>" + fase.nombre + "</h4>";
				
				$.each(fase.requisitos, function(claveRequisito, requisito){
					contLista += "<p><span class='ui-title-left'>" + requisito.nombre + ":</span><span class='sp-requisito'>" + requisito.valor + "</span></p>" +
							"<p><span class='sp-requisito'>" + requisito.comentario + "</span></p>";
				});
				if(fase.orden < lista.maxFases){
					contLista += "";
				}
				contLista += "</div>";
				$("#cp-lista").append(contLista);
			}
			
		});
		window.location.href = "#lista-page";
		$("#cp-lista").collapsibleset("refresh");
		$("#cp-lista").enhanceWithin();
	}
};

var toast = function(msg) {
	if(msg != null){
		$("<div class='ui-loader ui-overlay-shadow ui-body-e ui-corner-all' style='opacity:1; background-color:#CCCCCC;'><h3>"
						+ msg + "</h3></div>").css({
			display : "block",
			opacity : 1,
			position : "fixed",
			padding : "7px",
			"text-align" : "center",
			width : "270px",
			left : ($(window).width() - 284) / 2,
			top : $(window).height() / 2
		}).appendTo($.mobile.pageContainer).delay(1500).fadeOut(700, function() {
			$(this).remove();
		});
	}
};
